if not(isdedicatedserver) then return end

//Initialize namespace
rawset(_G,"CBW_HitStat",{}) //Table for recorded skin stats
rawset(_G,"CBW_HitStatIndex",{}) //Table for ordering names in stats
rawset(_G,"CBW_HitStatName",{}) //Reverse look-up table for the above


local filename = "hitstats.txt"
local file
local init_skins = 0 //Number of initialized skins
local stat = CBW_HitStat
local index = CBW_HitStatIndex
local name = CBW_HitStatName

//Write function
local Record = do
	//Open file
	file = io.openlocal(filename,"w+")
	for s = 1, #stat
		file:write(name[s].."\n" )
		for n = 1, #stat[s]
			file:write(tostring(stat[s][n]).."\n")
		end
	end
    print("Recorded hitstats to file: "..filename)
	io.close(file)
end

//Index a new name field
local count = 1
local IndexString = function(string)
	if index[string] == nil
		index[string] = count
		stat[count] = {}
		name[count] = string
		print("Indexed and registered "..string..", id #"..index[string])
		count = $+1
	end
	return index[string]
end

//Initialize and read file from stats
local fileloaded = false
local FileInit = function()
	if fileloaded == true then return end
	//Load file
	fileloaded = true
	file = io.openlocal(filename,"r")
	if file == nil
		print("No data found. Stats will be stored in luafiles/hitstats.txt at the end of each round.")
		return
	end
	print("Loaded "..filename)
		
	//Read from file
	local n1 = 0
	local n2 = 0
	local string = "error"
	for line in file:lines()
		if line != tostring(tonumber(line))
			IndexString(line)
			string = line
			n1= $+1
			n2 = 0
		elseif tonumber(line) != nil
			n2 = $+1
			stat[n1][n2] = tonumber(line) //e.g. CBW_HitStat["sonic"][1]
			print("Registered Hitstat: "..string.."["..n2.."] "..tostring(line))
		end
	end
	io.close(file)
end

//Initialize subtables (Runs whenever a new skin is detected)
local function InitStats()
	if #skins == init_skins return end
	//Make sure every skin name is registered in stats
	for skin in skins.iterate
-- 		if index[skin.name] == nil
-- 			init_skins = $+1
			IndexString(skin.name)
-- 		end
	end
	//Complete stat tables
-- 	print(index)
	for	n = 1, #stat
		local table = stat[n]
		for n = 1, #stat
			if table[n] == nil //Third layer namespace uninitialized
				table[n] = 0
			end
		end
	end
	//Update our count for initialized skins
	init_skins = #skins
	print("\x83"..init_skins.." skins are now registered for hitstat tracking.")
end

//Hooks
addHook("ThinkFrame",function()
	FileInit()
	InitStats()
end)
local intermission = false
addHook("MapLoad",do
	intermission = false
end)
addHook("IntermissionThinker",do
	if intermission == false
		intermission = true
		Record()
	end
end)