if not(isdedicatedserver) then return end

local AddStat = function(player1,player2,value,comment)
	local skin1 = player1.realmo.skin
	local skin2 = player2.realmo.skin
	local n1 = CBW_HitStatIndex[skin1]
	local n2 = CBW_HitStatIndex[skin2]
	value = $
	//Add point to stat
	CBW_HitStat[n1][n2] = $+value
	//Message output
	if value > 0
		value = "+"..tostring($)
	end
	local str = skin1.."|"..skin2.." "..tostring(value)
	if comment != nil
		str = $.." ("..tostring(comment)..")"
	end
	print(str)
end

addHook("MapLoad",do
	if not(CV_FindVar("hazardlog").value)
		print("NOTICE: hazardlog must be enabled to record hit statistics!")
	end
end)

addHook("HurtMsg",function(player,inflictor,source)
	local dead = player.mo.health == 0
	local comment = ""
	local points
	if not(dead)
		comment = "hit"
		points = 1
	else
		comment = "kill"
		points = 2
	end
	if inflictor and inflictor.valid and inflictor.player
		comment = "direct "..$
		AddStat(inflictor.player,player,points,comment)
		return true
	elseif source and source.valid and source.player
		comment = "projectile "..$
		AddStat(source.player,player,points,comment)
		return true
	end
	//Battle only; credits for hazard kills
	if player.pushed_creditplr and player.pushed_creditplr.valid and dead
		comment = "hazard "..$
		AddStat(player.pushed_creditplr,player,1,comment) //Only one point awarded for indirect kills
		return true
	end
end)